#include <windows.h>
#include <stdio.h>
#include <time.h>

// ASCII to ANSI character table
byte ASCII_Table[128] =
{
	199, 252, 233, 226, 228, 224, 229, 231, 234, 235, 232, 239, 238, 236, 196,
	197, 201, 230, 198, 244, 246, 242, 251, 249, 255, 214, 220, 248, 163, 216,
	215, 131, 225, 237, 243, 250, 241, 209, 170, 186, 191, 174, 172, 189, 188,
	161, 171, 187, 176, 177, 178, 179, 180, 193, 194, 192, 169, 185, 186, 187,
	188, 162, 165, 191, 192, 193, 194, 195, 196, 134, 227, 195, 200, 201, 202,
	203, 204, 205, 135, 164, 240, 208, 202, 203, 200, 213, 205, 206, 207, 217,
	218, 219, 220, 166, 204, 223, 211, 223, 212, 210, 245, 213, 181, 254, 222,
	218, 219, 217, 253, 221, 175, 180, 173, 177, 242, 190, 182, 167, 247, 184,
	176, 168, 183, 185, 179, 178, 254, 160
};
char* AsciiToAnsi(char *asciistr) {
	byte	*spos = (byte*)asciistr;

	while(*spos) {
		if(*spos > 127) *spos = ASCII_Table[*spos - 128];
		spos += 1;
	}
	return asciistr;
}

// ANSI to ASCII character table
byte ANSI_Table[128] =
{
	 63,  63,  39, 159,  34,  46, 197, 206,  94,  37,  83,  60,  79,  63,  90,
	 63,  63,  39,  39,  34,  34,   7,  45,  45, 126,  84, 115,  62, 111,  63,
	122,  89, 255, 173, 189, 156, 207, 190, 221, 245, 249, 184, 166, 174, 170,
	240, 169, 238, 248, 241, 253, 252, 239, 230, 244, 250, 247, 251, 167, 175,
	172, 171, 243, 168, 183, 181, 182, 199, 142, 143, 146, 128, 212, 144, 210,
	211, 222, 214, 215, 216, 209, 165, 227, 224, 226, 229, 153, 158, 157, 235,
	233, 234, 154, 237, 232, 225, 133, 160, 131, 198, 132, 134, 145, 135, 138,
	130, 136, 137, 141, 161, 140, 139, 208, 164, 149, 162, 147, 228, 148, 246,
	155, 151, 163, 150, 129, 236, 231, 152
};
char* AnsiToAscii(char *ansistr) {
	byte	*spos = (byte*)ansistr;

	while(*spos) {
		if(*spos > 127) *spos = ANSI_Table[*spos - 128];
		spos += 1;
	}
	return ansistr;
}

enum LangStrings {
	strWarningWindowsNT,
	strDescriptionApp,
	strWarningArgumentS,
	strOutputArray,
	strOutputNormal,
	strErrorEvent6009,
	strErrorMalloc,
	strErrorOpenEventLog
};

char	*strings[7];

void setstrings() {
	LANGID	lang;

	lang = GetUserDefaultLangID();

	switch(lang) {
	// german language strings
	case 0x0407:
	case 0x0807:
	case 0x0c07:
	case 0x1007:
	case 0x1407:
		strings[strWarningWindowsNT]	= "Uptime kann nur auf Windows NT/2000/XP-Computern ausgefhrt werden!\n";
		strings[strDescriptionApp]		= "\nUptime bestimmt die Laufzeit des angegebenen Windows NT/2000/XP-Computers (engl. up time). Die Laufteit ist die seit dem letzten Systemstart vergangene Zeit.\nCopyright C2002 Michael Berthold\nURL: http://www.bertel.de/software/uptime\n\nSyntax: uptime {[/a] [/s <Computer>] | /?}\n\n/a\t(Optional) Legt die Ausgabe der Zeit in separaten Zeilen fest.\n\t(Besonders ntzlich, wenn die Ausgabe werterverarbeitet werden soll)\n/s\t(Optional) Bestimmt den Namen des zu befragenden Computers <Computer>.\n\t(NetBIOS-Name, DNS-Name oder IP-Adresse ist mglich)\n/?\tZeigt diese Hilfsinformationen an.\n\t(Dieses Argument muss allein angegeben werden)\n\nDie Reihenfolge der Argumente ist nicht beliebig!\n\nBeispiele:\nuptime /a\nuptime /s 127.0.0.1\nuptime /a /s Compi12\nuptime /?\n";
		strings[strWarningArgumentS]	= "Das Argument /smuss von einem Computernamen gefolgt werden! Geben Sie fr Hilfe 'uptime /?' ein.\n";
		strings[strOutputArray]			= "%d Jahre\n%d Tage\n%d Stunden\n%d Minuten\n%d Sekunden\n";
		strings[strOutputNormal]		= "Laufzeit: %d Jahre, %d Tage, %d Stunden, %d Minuten und %d Sekunden.\n";
		strings[strErrorEvent6009]		= "Ereignis 6009 wurde im Ereignisprotokoll 'System' nicht gefunden!\nReadEventLog-Fehler: %sminNumberOfBytesNeeded: %d\n";
		strings[strErrorMalloc]			= "malloc-Fehler: %s";
		strings[strErrorOpenEventLog]	= "OpenEventLog-Fehler: %s";
		break;
	// default are english language strings
	default:
		strings[strWarningWindowsNT]	= "Uptime can be executed on Windows NT/2000/XP computers only!\n";
		strings[strDescriptionApp]		= "\nUptime retrieves the up time of the specified Windows NT/2000/XP computer. The up time is the time gone since the last system boot.\nCopyright C2002 by Michael Berthold\nURL: http://www.bertel.de/software/uptime\n\nusage: uptime {[/a] [/s <computer>] | /?}\n\n/a\t(optional) specifies that the output time is written in separate lines.\n\t(especially useful when the output has to be processed)\n/s\t(optional) specifies the name of the target computer <computer>.\n\t(NetBIOS name, DNS name or IP address is possible)\n/?\tshows uptime help information.\n\t(this argument must be set alone)\n\nThe arguments order is not variable!\nExamples:\nuptime /a\nuptime /s 127.0.0.1\nuptime /a /s Compi12\nuptime /?\n";
		strings[strWarningArgumentS]	= "The argument /s must be followed by a computer name! Type 'uptime /?' for help.\n";
		strings[strOutputArray]			= "%d years\n%d days\n%d hours\n%d minutes\n%d seconds\n";
		strings[strOutputNormal]		= "Up time: %d years, %d days, %d hours, %d minutes, and %d seconds.\n";
		strings[strErrorEvent6009]		= "Event 6009 not found in system log!\nReadEventLog error: %sminNumberOfBytesNeeded: %d\n";
		strings[strErrorMalloc]			= "malloc error: %s";
		strings[strErrorOpenEventLog]	= "OpenEventLog error: %s";
	}
}

LPTSTR strerror(DWORD code) {
	LPTSTR	lpMsgBuf;
	if(FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
	code, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL)) {
		return AnsiToAscii(lpMsgBuf);
	} else {
		return NULL;
	}
}

int main(int argc, char* argv[])
{
	OSVERSIONINFO	versionInfo;
	HANDLE			hEventLog;
	_EVENTLOGRECORD	*buffer;
	DWORD			bufferSize, recordNumber, bytesRead, minNumberOfBytesNeeded;
	WORD			eventID;
	LPTSTR			lpMsgBuf, lpEventSource;
	BOOL			arrayOut = FALSE, result, found = FALSE;
	int				i, returnCode = 0;
	time_t			eventTime, sysTime;
	struct tm		*elapsedTime;
	char			computer[128];

	setstrings();
	computer[0] = 0;

	versionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if(GetVersionEx(&versionInfo)) {
		if(versionInfo.dwPlatformId != VER_PLATFORM_WIN32_NT) {
			printf(strings[strWarningWindowsNT]);
			return -1;
		}
	} else {
		lpMsgBuf = strerror(GetLastError());
		if(lpMsgBuf) {
			printf("GetVersionEx error: %s", lpMsgBuf);
			LocalFree((LPVOID)lpMsgBuf);
		}
		return -1;
	}

	i = 1;
	if(argc > i) {
		if(!strcmp(argv[i], "/?")) {
			printf(strings[strDescriptionApp]);
			return 0;
		} else if(!strcmp(argv[i], "/a")) {
			arrayOut = TRUE;
			i++;
		}
		if(argc > i) {
			if(!strcmp(argv[i], "/s")) {
				i++;
				if(argc > i) {
					_snprintf(computer, 128, "\\\\%s", argv[i]);
				} else {
					printf(strings[strWarningArgumentS]);
					return -1;
	}	}	}	}

	hEventLog = OpenEventLog(computer, "System");
	if(hEventLog) {
		bufferSize = 1024;
		buffer = (_EVENTLOGRECORD*)malloc(bufferSize);
		if(buffer) {
			result = ReadEventLog(hEventLog, EVENTLOG_SEQUENTIAL_READ | EVENTLOG_BACKWARDS_READ, 0, buffer, bufferSize, &bytesRead, &minNumberOfBytesNeeded);
			recordNumber = buffer->RecordNumber;
			while(result) {
				if(buffer->EventType == EVENTLOG_INFORMATION_TYPE) {
					eventID = LOWORD(buffer->EventID);
					if(eventID == 6009) {
						lpEventSource = (LPTSTR)buffer;
						lpEventSource += sizeof(_EVENTLOGRECORD);
						if(!stricmp(lpEventSource, "eventlog")) {
							eventTime = time(&sysTime) - buffer->TimeGenerated;
							elapsedTime = gmtime(&eventTime);
							if(arrayOut) {
								printf(strings[strOutputArray], elapsedTime->tm_year - 70, elapsedTime->tm_yday, elapsedTime->tm_hour, elapsedTime->tm_min, elapsedTime->tm_sec);
							} else {
								printf(strings[strOutputNormal], elapsedTime->tm_year - 70, elapsedTime->tm_yday, elapsedTime->tm_hour, elapsedTime->tm_min, elapsedTime->tm_sec);
							}
							found = TRUE;
							break;
				}	}	}
				recordNumber--;
				result = ReadEventLog(hEventLog, EVENTLOG_SEEK_READ | EVENTLOG_BACKWARDS_READ, recordNumber, buffer, bufferSize, &bytesRead, &minNumberOfBytesNeeded);
			}
			free(buffer);
			if(!found) {
				lpMsgBuf = strerror(GetLastError());
				if(lpMsgBuf) {
					printf(strings[strErrorEvent6009], lpMsgBuf, minNumberOfBytesNeeded);
					LocalFree((LPVOID)lpMsgBuf);
				}
				returnCode = -1;
			}
		} else {
			lpMsgBuf = strerror(GetLastError());
			if(lpMsgBuf) {
				printf(strings[strErrorMalloc], lpMsgBuf);
				LocalFree((LPVOID)lpMsgBuf);
			}
			returnCode = -1;
		}
		CloseEventLog(hEventLog);
	} else {
		lpMsgBuf = strerror(GetLastError());
		if(lpMsgBuf) {
			printf(strings[strErrorOpenEventLog], lpMsgBuf);
			LocalFree((LPVOID)lpMsgBuf);
		}
		returnCode = -1;
	}

	return returnCode;
}
